local AssignSoldier = ...

-- Register all stone gate set building parts and their properties
AssignSoldier:dofile("scripts/compPathAccess.lua")
AssignSoldier:dofile("scripts/compPathAEnd.lua")
AssignSoldier:dofile("scripts/basicWorkplace.lua")
AssignSoldier:dofile("scripts/behavior_tree.lua")

-- Register the stone gate set monument
if _flagSg7 then
-- Adds the specific materials od Soldier Assignment to the already existing list of themes
    function configureMaterialSet2(_colorRoof, _colorWall, _colorCrenellation, _colorBasement, _colorFloorGround, _colorFrame, _defaultMaterial, _custom)
        function configureSimpleRoofAccessMaterial(_core)
            if _defaultMaterial then
                return _assignSoldierPrefix .. "_" .. _core .. "_" .. _colorRoof .. "_ROOF_MATERIAL"
            else
                return _CommonWindowPrefix .. "_DECORATION_" .. _colorRoof .. "_ROOF_MATERIAL"
            end
        end
        function configureWallAccessMaterial(_core)
            if _defaultMaterial then
                return _assignSoldierPrefix .. "_" .. _core .. "_" .. _colorWall .. "_WALL_MATERIAL"
            else
                return _CommonWindowPrefix .. "_DECORATION_" .. _colorWall .. "_WALL_MATERIAL"
            end
        end

        AssignSoldier:log("init configureMaterialSet")
        local materialSet = configureMaterialSet(_colorRoof, _colorWall, _colorCrenellation, _colorBasement, _colorFloorGround, _colorFrame, _defaultMaterial, _custom)
        AssignSoldier:log("init configureMaterialSet")
        table.insert(materialSet.MaterialList, configureSimpleRoofAccessMaterial("OTOWER"))
        table.insert(materialSet.MaterialList, configureWallAccessMaterial("OTOWER"))
        AssignSoldier:log("end configureMaterialSet" .. tostring(materialSet))
        return materialSet
    end


    AssignSoldier:override({
        Id = _StoneGateSetPrefix .. "_MONUMENT",
        BuildingPartSetList = {
                Action = "APPEND",
		{
			Name = _StoneGateSetPrefix .. "_ENTRANCE_PARTSETLIST_NAME",
                	BuildingPartList = {
                            _assignSoldierPrefix .. "_KEEP_TRAP_ACCESS_PART",
                            _assignSoldierPrefix .. "_SMALL_GATE_ACCESS_R_PART",
                            _assignSoldierPrefix .. "_SMALL_GATE_ACCESS_L_PART",
                            _assignSoldierPrefix .. "_OCTOGONAL_TOWER_ACCESS_PART",
                        }
                }
        },
        MaterialSetList = configureMaterialSetList(configureMaterialSet2)
    })
end
